package net.rping.my.web.app;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.preference.EditTextPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceScreen;
import android.util.Log;
import android.webkit.URLUtil;
import android.widget.Toast;


public class PrefActivity extends PreferenceActivity implements OnPreferenceChangeListener 
{	
	private EditTextPreference editTextPreference;
	private static final String LOGTAG = "MYAPP";
	
	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		addPreferencesFromResource(R.xml.preference);

		// get UI object references
		PreferenceScreen prefSet = getPreferenceScreen();
		editTextPreference = (EditTextPreference)prefSet.findPreference("pref_homepage");
		Log.d(LOGTAG, "checking findPreference, editTextPreference=" + editTextPreference.toString());
		
		Log.d(LOGTAG, "start loading homepage url");
		String homepageUrl = PrefHomepage.getHomepageUrl(getApplicationContext());

		Log.d(LOGTAG, "Setting homepageUrl:" + homepageUrl);		
		if (homepageUrl.length() > 7)
		{
			Log.d(LOGTAG, "homepageUrl=" + homepageUrl);
			editTextPreference.setSummary(homepageUrl);
		}
		editTextPreference.setOnPreferenceChangeListener(this);

		Log.d(LOGTAG, "PrefActivity.onCreate done");
	}

	@SuppressLint("ShowToast")
	public boolean onPreferenceChange(Preference preference, Object newValue)
	{
		if (preference == editTextPreference)
		{
			Log.d(LOGTAG, "onPreferenceChange");
			String homepageUrl = (String)newValue;
			Log.d(LOGTAG, "homepageUrl=" + homepageUrl);
			
			Context context = getApplicationContext();
			if (homepageUrl.length() > 0)
			{
				if (URLUtil.isValidUrl("http://" + homepageUrl.trim()))
				{
					Log.d(LOGTAG, "homepageUrl is valid, saving");
					PrefHomepage.setHomepageUrl(context, "http://" + homepageUrl);
					
					editTextPreference.setSummary(homepageUrl);
					
					return true;
				}
				else
				{
					Log.d(LOGTAG, "homepageUrl is not valid, toasting");
					Toast.makeText(PrefActivity.this, homepageUrl + " is not a valid web address", Toast.LENGTH_SHORT).show();
					return false;
				}
			}
			else
			{
				Log.d(LOGTAG,"setting homepageUrl null");
				PrefHomepage.setHomepageUrl(context, "");
				
				editTextPreference.setSummary("Set the Home page with remote web address");
				
				return true;
			}
		}
		return false;
	}
}
