package net.rping.my.web.app;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.webkit.URLUtil;
import android.widget.Toast;

public class PrefHomepage 
{
    public final static String PREFS_NAME = "pref_homepage";
    
    public static String getHomepageUrl(Context context) 
    {
        SharedPreferences prefs = context.getSharedPreferences(PREFS_NAME, Context.MODE_PRIVATE);
        return prefs.getString(context.getString(R.string.pref_homepage_key), "http://");
    }
    
    @SuppressLint("ShowToast")
	public static void setHomepageUrl(Context context, String newValue) 
    {
		SharedPreferences prefs = context.getSharedPreferences(PREFS_NAME, Context.MODE_PRIVATE);
		Editor prefsEditor = prefs.edit();

    	if (newValue.length() > 7)
    	{
    		if (URLUtil.isValidUrl(newValue.trim()))
    		{
    			prefsEditor.putString(context.getString(R.string.pref_homepage_key), newValue.trim());
    			prefsEditor.commit();
    		}
    		else
    		{
    			Toast.makeText(context, newValue + " is not a valid web address", Toast.LENGTH_SHORT);
    		}
    	}
    	else
    	{
			prefsEditor.putString(context.getString(R.string.pref_homepage_key), "");
			prefsEditor.commit();    		
    	}
        return;
    }
}
